﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.IO;
using wordProcessing;
using SOM;

namespace SOMtest
{
    class Program
    {
        static void Main(string[] args)
        {
            string rootFolder = @"..//..//..//..//PATENTCORPUS128";
            string extension = "*.txt";
            string dataFolder = "data";
            string filesList = "ProcessedFilesList.txt";
            string dataFile = "DocWordMatrix.dat";
            string path = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);
            dataFolder = Path.Combine(path, dataFolder);
            filesList = Path.Combine(dataFolder, filesList);
            dataFile = Path.Combine(dataFolder, dataFile);

            DirectoryInfo di = new DirectoryInfo(rootFolder);
            if (!di.Exists)
            {
                Console.WriteLine("The data folder not found, please correct the path");
                return;
            }

            DateTime start = DateTime.Now;
            //
            WordProcessing wp = new WordProcessing(dataFolder, filesList, dataFile);
            wp.processFiles(rootFolder, extension);
            //
            SOMcs som = new SOMcs();
            som.readDataAndMakeRandomMap(dataFile);
            som.makeSOM();
            som.estimateAccuracyForPatentCorpus128();
            //
            DateTime end = DateTime.Now;
            TimeSpan duration = end - start;
            double time = duration.Minutes * 60.0 + duration.Seconds + duration.Milliseconds / 1000.0;
            Console.WriteLine("Total processing time {0:########.00} seconds", time);
        }
    }
}
